package nazou.support.jobofferportal.repository;

import java.util.ArrayList;
import java.util.List;

/**
 * 
 * Bean containing metadata about the job offer fields
 * 
 * @author Peter Bartalos
 *
 */
public class OfferFieldMetadataObject {

	private String beanFieldName = null;
	private String ontologyPropertyURI = null;
	private String type = null;
	private String recursive = null;
	private String recursivelyDelete = null;
	private String objectNamespace = null;
	private String multiple = null;
	private String beanName = null;
	private List<MyStatement> newEntityTriples = null;
	
	
	public OfferFieldMetadataObject() {
		newEntityTriples = new ArrayList<MyStatement>(); 
	}


	public String getBeanFieldName() {
		return beanFieldName;
	}


	public void setBeanFieldName(String beanFieldName) {
		this.beanFieldName = beanFieldName;
	}


	public String getOntologyPropertyURI() {
		return ontologyPropertyURI;
	}


	public void setOntologyPropertyURI(String ontologyPropertyURI) {
		this.ontologyPropertyURI = ontologyPropertyURI;
	}


	public String getRecursive() {
		return recursive;
	}


	public void setRecursive(String recursive) {
		this.recursive = recursive;
	}


	public String getRecursivelyDelete() {
		return recursivelyDelete;
	}


	public void setRecursivelyDelete(String recursivelyDelete) {
		this.recursivelyDelete = recursivelyDelete;
	}


	public String getType() {
		return type;
	}


	public void setType(String type) {
		this.type = type;
	}


	public List<MyStatement> getNewEntityTriples() {
		return newEntityTriples;
	}
	
	public void addNewEntityTriple(MyStatement newStatement){
		getNewEntityTriples().add(newStatement);
	}


	public String getObjectNamespace() {
		return objectNamespace;
	}


	public void setObjectNamespace(String objectNamespace) {
		this.objectNamespace = objectNamespace;
	}


	public String getMultiple() {
		return multiple;
	}


	public void setMultiple(String multiple) {
		this.multiple = multiple;
	}


	public String getBeanName() {
		return beanName;
	}


	public void setBeanName(String beanName) {
		this.beanName = beanName;
	}
}
