package nazou.support.jobofferportal.repository;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.util.Properties;

/**
 * 
 * Class for reading the property file containing access parameter for sesame repository connection
 * Reads a file named: "RepositoryAccess.properties" in /webapps/cocoon/portal/
 * 
 * @author Peter Bartalos
 *
 */
public class PropertyReader {


	private String repositoryID = null;
	private String repositoryURL = null;
	private String userPassword = null;
	private String userName = null;
	
	
	
	public static void main(String[] args) {

		PropertyReader reader = new PropertyReader();
		reader.loadProperties();
		
		System.out.println(reader.getRepositoryURL());
		System.out.println(reader.getRepositoryID());
		System.out.println(reader.getUserName());
		System.out.println(reader.getUserPassword());

	}

	/**
	 * 
	 * loads the properties from file
	 */
	public void loadProperties(){
		try{
			Properties properties = new Properties();
			
			FileInputStream in = new FileInputStream("webapps/cocoon/portal/RepositoryAccess.properties");
			properties.load(in);

			setRepositoryURL(properties.getProperty("repositoryURL").toString());

			setRepositoryID(properties.getProperty("repositoryID").toString());
			
			setUserName(properties.getProperty("userName").toString());

			setUserPassword(properties.getProperty("userPassword").toString());

			
		}
		catch(Exception e){
			e.printStackTrace();
			System.out.println(e.getMessage());
		}
		
	}

	public String getRepositoryID() {
		return repositoryID;
	}


	public void setRepositoryID(String repositoryID) {
		this.repositoryID = repositoryID;
	}


	public String getRepositoryURL() {
		return repositoryURL;
	}


	public void setRepositoryURL(String repositoryURL) {
		this.repositoryURL = repositoryURL;
	}


	public String getUserName() {
		return userName;
	}


	public void setUserName(String userName) {
		this.userName = userName;
	}


	public String getUserPassword() {
		return userPassword;
	}


	public void setUserPassword(String userpassword) {
		this.userPassword = userpassword;
	}
	
	
	

}
