package nazou.support.jobofferportal.repository;

import java.util.*;

import org.openrdf.model.Value;
import org.openrdf.sesame.config.AccessDeniedException;
import org.openrdf.sesame.constants.QueryLanguage;
import org.openrdf.sesame.query.QueryResultsTable;
import org.openrdf.sesame.repository.SesameRepository;

/**
 * 
 * Retrieving of ID lists from repository
 * 
 * @author Peto
 *
 */
public class SesameRepositoryDataRetriever {

	private SesameRepository repository;
	private Namespaces namespace;
	
	
	
	public SesameRepositoryDataRetriever(SesameRepository _repository) {
		super();
		repository= _repository;
		namespace= new Namespaces();
	}

	public List<String> getAllOfferIDsFromRepository(){

		List<String> offerIDs= new ArrayList<String>();
		
		try{
//			System.out.println("Getting all offer IDs");
			String query = "SELECT localName(offer)	FROM {offer} rdf:type {jo:JobOffer}	using namespace jo = <"+ namespace.getNamespaceJo() +">, rdf = <"+ namespace.getNamespaceRdf() +">";
			QueryResultsTable resultsTable = getRepository().performTableQuery(QueryLanguage.SERQL, query);
			int rowCount = resultsTable.getRowCount();
			int columnCount = resultsTable.getColumnCount();

			for (int row = 0; row < rowCount; row++) {
			    for (int column = 0; column < columnCount; column++) {
			        Value value = resultsTable.getValue(row, column);

			        if (value != null) {
//			            System.out.print("id: " + value.toString());
			            offerIDs.add(new String(value.toString()));
			        }
			        else {
			            System.out.print("null");
			        }

//			        System.out.print("\t");
			    }

//			    System.out.println();
			}
			
			return offerIDs;

		}
		catch(IllegalArgumentException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch(AccessDeniedException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch (Exception e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}

	}

	public List<String> getAllOrganizationIDsFromRepository(){

		List<String> organizationIDs= new ArrayList<String>();
		
		try{
			System.out.println("Getting all organization IDs");
			String query = "SELECT localName(organization)	FROM {organization} rdf:type {jo:Organization}	using namespace jo = <"+ namespace.getNamespaceJo() +">, rdf = <"+ namespace.getNamespaceRdf() +">";
			QueryResultsTable resultsTable = getRepository().performTableQuery(QueryLanguage.SERQL, query);
			int rowCount = resultsTable.getRowCount();
			int columnCount = resultsTable.getColumnCount();

			for (int row = 0; row < rowCount; row++) {
			    for (int column = 0; column < columnCount; column++) {
			        Value value = resultsTable.getValue(row, column);

			        if (value != null) {
//			            System.out.print("id org: " + value.toString());
			            organizationIDs.add(new String(value.toString()));
			        }
			        else {
			            System.out.print("null");
			        }

//			        System.out.print("\t");
			    }

//			    System.out.println();
			}
			
			return organizationIDs;

		}
		catch(IllegalArgumentException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch(AccessDeniedException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch (Exception e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}

	}

	public List<String> getAllSalaryIDsFromRepository(){

		List<String> salaryIDs= new ArrayList<String>();
		
		try{
			System.out.println("Getting all salary IDs");
			String query = "SELECT localName(salary)	FROM {salary} rdf:type {jo:Salary}	using namespace jo = <"+ namespace.getNamespaceJo() +">, rdf = <"+ namespace.getNamespaceRdf() +">";
			QueryResultsTable resultsTable = getRepository().performTableQuery(QueryLanguage.SERQL, query);
			int rowCount = resultsTable.getRowCount();
			int columnCount = resultsTable.getColumnCount();

			for (int row = 0; row < rowCount; row++) {
			    for (int column = 0; column < columnCount; column++) {
			        Value value = resultsTable.getValue(row, column);

			        if (value != null) {
//			            System.out.print("id: " + value.toString());
			            salaryIDs.add(new String(value.toString()));
			        }
			        else {
			            System.out.print("null");
			        }

//			        System.out.print("\t");
			    }

//			    System.out.println();
			}
			
			return salaryIDs;

		}
		catch(IllegalArgumentException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch(AccessDeniedException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch (Exception e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}

	}
	
	
	public List<String> getAllBenefitIDsFromRepository(){

		List<String> benefitIDs= new ArrayList<String>();
		
		try{
			System.out.println("Getting all benefit IDsaaaaa");
			//String query = "SELECT localName(benefit)	FROM {benefit} rdf:type {jo:Benefit}using namespace jo = <"+ namespace.getNamespaceJo() +">, rdf = <"+ namespace.getNamespaceRdf() +">";
			String query = "SELECT localName(instancia) FROM {instancia} rdf:type {Podtrieda} WHERE Podtrieda IN (SELECT Subclass FROM {Subclass} rdfs:subClassOf {jo:Benefit}) using namespace jo = <"+ namespace.getNamespaceJo() +">";
			QueryResultsTable resultsTable = getRepository().performTableQuery(QueryLanguage.SERQL, query);
			int rowCount = resultsTable.getRowCount();
			int columnCount = resultsTable.getColumnCount();

			for (int row = 0; row < rowCount; row++) {
			    for (int column = 0; column < columnCount; column++) {
			        Value value = resultsTable.getValue(row, column);

			        if (value != null) {
//			            System.out.print("id: " + value.toString());
			            benefitIDs.add(new String(value.toString()));
			        }
			        else {
			            System.out.print("null");
			        }

//			        System.out.print("\t");
			    }

//			    System.out.println();
			}
			
			return benefitIDs;

		}
		catch(IllegalArgumentException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch(AccessDeniedException e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}
		catch (Exception e){
			System.out.println("Error occured");			
			e.printStackTrace();
			return null;
		}

	}
	
	public SesameRepository getRepository() {
		return repository;
	}

	public void setRepository(SesameRepository repository) {
		this.repository = repository;
	}
	
}
